<!DOCTYPE html>
<html class="zc-html">

<head>
    <meta charset="utf-8">
    <title>Dag Dep Graph</title>
    <script src="https://cdn.zingchart.com/zingchart.min.js"></script>
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js"></script>
    <style>
        .zc-html,
        .zc-body {
            margin: 0;
            padding: 0;
            width: 100%;
            height: 100%;
        }

        .chart--container {
            height: 100%;
            width: 100%;
            min-height: 530px;
        }
    </style>
</head>

<body class="zc-body">
<!-- CHART CONTAINER -->
<div id="myChart" class="chart--container">
    <div style="display: flex; align-items: center; margin-top: 10px; justify-content: center">
        <input type="file" id="json-picker" accept=".json"/>
        <input id="search-annotation"/>
        <button id="search-button">Search</button>
        <label for="searched-nodes" style="margin-left: 60px">Result: </label>
        <select id="searched-nodes" style="width: 600px">
        </select>
    </div>
</div>
<script>
    ZC.LICENSE = ["569d52cefae586f634c54f86dc99e6a9", "b55b025e438fa8a98e32482b5f768ff5"]; // window:load event for Javascript to run after HTML

    window.addEventListener('load', () => {
        let nodes = [];
        let searchResult = [];
        let chartData = [];
        let chartConfig = {
            "type": "tree",
            "options": {
                "aspect": 'tree-left',
                "link": {
                    "aspect": "arc"
                },
                "maxSize": 10,
                "minSize": 4,
                "node": {
                    "type": "circle",
                    "borderWidth": 0,
                    "tooltip": {
                        "fontSize": "10px"
                    },
                    "size": 10,
                    "hoverState": {
                        "borderAlpha": 1,
                        "borderColor": "#000",
                        "borderWidth": "2px"
                    },
                    "label": {
                        "width": "100px"
                    }
                },
                "progression": 0,
                "textAttr": "name",
                "valueAttr": "value"
            },
            series: chartData
        };

        document.getElementById('search-button').onclick = () => {
            const q = document.getElementById('search-annotation').value;
            const foundNodes = [];
            for (let i = 0; i < nodes.length; i++) {
                if (nodes[i].Annotation.includes(q)) {
                    foundNodes.push(nodes[i]);
                }
            }
            searchResult = foundNodes;
            addOptionsToSelect(document.getElementById('searched-nodes'), searchResult.map((sr) => ({
                value: sr.DebugActionIndex,
                innerHTML: sr.Annotation
            })));
            chartConfig.series = nodesChain(searchResult[0], null)
            console.log(chartConfig)
            zingchart.exec('myChart', 'setdata', {
                data: chartConfig
            });
        }

        document.getElementById('searched-nodes').addEventListener('change', function (e) {
            chartConfig.series = nodesChain(findNodeByIdx(e.srcElement.value), null)
            zingchart.exec('myChart', 'setdata', {
                data: chartConfig
            });
        });

        document.getElementById('json-picker').addEventListener('change', function (e) {
            let reader = new FileReader();
            reader.onload = (event)=>{
                let data = JSON.parse(event.target.result);
                nodes = (data.Nodes || []);
                // if too many nodes, just slice the first one.
                if (nodes.length > 20) {
                    nodes = nodes.slice(1);
                }
                searchResult = nodes;
                addOptionsToSelect(document.getElementById('searched-nodes'), searchResult.map((sr) => ({
                    value: sr.DebugActionIndex,
                    innerHTML: sr.Annotation
                })));
                chartConfig.series = nodesChain(searchResult[0], null)
                console.log(chartConfig)
                zingchart.render({
                    id: 'myChart',
                    data: chartConfig,
                    height: '95%',
                    width: '80%',
                    output: 'canvas'
                });
            };
            reader.readAsText(e.target.files[0]);
        });

        // helpers
        const retrieveNodeMeta = (node) => (
            {
                id: node.DebugActionIndex + '',
                name: node.DebugActionIndex + '',
                value: node.Annotation,
            }
        )

        const findNodeByIdx = (idx) => {
            return nodes.find((node) => node.DebugActionIndex == idx);
        }

        function nodesChain(node, parent = '', helperMap = {}) {
            if (!node || Object.keys(node).length === 0) {
                return []
            }
            if (helperMap[node.DebugActionIndex] != null && helperMap[node.DebugActionIndex] === parent) {
                return []
            }
            console.log(parent)
            let tmp = [Object.assign(retrieveNodeMeta(node), {parent: parent != null && parent !== '' && parent + '' || ''})];
            helperMap[node.DebugActionIndex] = parent;
            for (let i = 0; i < (node.Deps || []).length; i++) {
                // push & override
                const nodes = nodesChain(findNodeByIdx(node.Deps[i]), node.DebugActionIndex, helperMap);
                for (let j = 0; j < nodes.length; j++) {
                    let existId = tmp.findIndex((t) => t.id === nodes[j].id);
                    if (existId >= 0) {
                        tmp.splice(existId, 1, nodes[j]);
                    } else {
                        tmp.push(nodes[j]);
                    }
                }
                helperMap[node.Deps[i]] = parent;
            }
            return tmp;
        }

        function addOptionsToSelect(select, options) {
            removeOptions(select);
            for (let i = 0; i < options.length && i < 100; i++) {
                let opt = document.createElement('option');
                opt.value = options[i].value;
                opt.innerHTML = options[i].innerHTML;
                select.appendChild(opt);
            }
        }

        function removeOptions(selectElement) {
            let i, L = selectElement.options.length - 1;
            for (i = L; i >= 0; i--) {
                selectElement.remove(i);
            }
        }
    });
</script>
</body>

</html>
